
    ----------------------------------------------------------------------------
    -- App für die Telemetriedaten des Mezon-Reglers umgeschrieben von A.Straßburg
    ----------------------------------------------------------------------------
 	
	--[[
	
	MIT License
	
    Copyright (c) 2017 A. Fromm
   
    Hiermit wird unentgeltlich jeder Person, die eine Kopie der Software und der
    zugehörigen Dokumentationen (die "Software") erhält, die Erlaubnis erteilt,
    sie uneingeschränkt zu nutzen, inklusive und ohne Ausnahme mit dem Recht, sie
    zu verwenden, zu kopieren, zu verändern, zusammenzufügen, zu veröffentlichen,
    zu verbreiten, zu unterlizenzieren und/oder zu verkaufen, und Personen, denen
    diese Software überlassen wird, diese Rechte zu verschaffen, unter den
    folgenden Bedingungen: 
    Der obige Urheberrechtsvermerk und dieser Erlaubnisvermerk sind in allen Kopien
    oder Teilkopien der Software beizulegen. 
    DIE SOFTWARE WIRD OHNE JEDE AUSDRÜCKLICHE ODER IMPLIZIERTE GARANTIE BEREITGESTELLT,
    EINSCHLIEßLICH DER GARANTIE ZUR BENUTZUNG FÜR DEN VORGESEHENEN ODER EINEM
    BESTIMMTEN ZWECK SOWIE JEGLICHER RECHTSVERLETZUNG, JEDOCH NICHT DARAUF BESCHRÄNKT.
    IN KEINEM FALL SIND DIE AUTOREN ODER COPYRIGHTINHABER FÜR JEGLICHEN SCHADEN ODER
    SONSTIGE ANSPRÜCHE HAFTBAR ZU MACHEN, OB INFOLGE DER ERFÜLLUNG EINES VERTRAGES,
    EINES DELIKTES ODER ANDERS IM ZUSAMMENHANG MIT DER SOFTWARE ODER SONSTIGER
    VERWENDUNG DER SOFTWARE ENTSTANDEN. 
	----------------------------------------------------------------------------
    
	--]]
	   
collectgarbage()
--------------------------------------------------------------------------------
local initAnimation = true
local model, owner = " ", " "
local playDone, sensorId, sensorPa, alarmValue
local sensid1, sensid2, sensid3, sensid4, sensid5 = 0, 0.0, 0, 0.0, 0
local sensid6, sensid7, sensid8 = 0, 0, 0
local hoehe = 0
local capa1, remaining = 0, 0
local maxcur = 0
local time, lastTime, newTime = 0, 0, 0
local std, min, sec = 0, 0, 0

--------------------------------------------------------------------------------
-- Read translations
local function setLanguage()
    local lng=system.getLocale()
    local file = io.readall("Apps/Lang/Mezon.jsn")
    local obj = json.decode(file)
    if(obj) then
        trans = obj[lng] or obj[obj.default]
    end
end
--------------------------------------------------------------------------------
-- Draw Battery and percentage display
local function drawBattery(Value, Alarm)
    local laenge 

		-- Battery
	if (Value) then
		lcd.drawRectangle(134, 55, 52, 103)
		lcd.drawFilledRectangle(148, 48, 24, 7)
		chgY = (160 - (Value * 1.03))
		chgH = ((Value * 1.03) - 2)
        if( Value < Alarm ) then	
        	lcd.setColor(255, 0, 0)	
        else
			  lcd.setColor(0, 255, 0)		
        end	
			lcd.drawFilledRectangle(135, chgY, 50, chgH)
        if( Value > Alarm ) then	    -- Ab Alarmschwelle mit Rot füllen
		    lcd.setColor(255, 0, 0)
            chgY = (160 - (Alarm * 1.03))
		    chgH = ((Alarm * 1.03) - 2)
            lcd.drawFilledRectangle(135, chgY, 50, chgH)
        end
	else
		lcd.drawRectangle(134, 55, 52, 103)
		lcd.setColor(0, 255, 0)
	    lcd.drawFilledRectangle(148, 48, 24, 7)
	end
	lcd.setColor(255, 255, 255)

		-- Percentage Display
    laenge = lcd.getTextWidth(FONT_MAXI, string.format("%.0f",Value))
		if( Value > Alarm ) then	
			lcd.drawRectangle(125, 2, 70, 43, 6)
		 	lcd.drawRectangle(124, 1, 72, 45, 7)
			lcd.drawText(150 - (laenge/2) ,4, string.format("%.0f",Value),FONT_MAXI)
   		lcd.drawText(151 - (laenge/2) + laenge ,20, "%",FONT_NORMAL)
  	else
		if( system.getTime() % 2 == 0 ) then -- blink every second

		  	lcd.drawRectangle(125, 2, 70, 43, 6)
		   	lcd.drawRectangle(124, 1, 72, 45, 7)
			lcd.setColor(255, 0, 0)
		  	lcd.drawText(150 - (laenge/2) ,4, string.format("%.0f",Value),FONT_MAXI)
    		lcd.drawText(151 - (laenge/2) + laenge ,20, "%",FONT_NORMAL)
		    lcd.setColor(255, 255, 255)
		end
	end
    collectgarbage()
end
--------------------------------------------------------------------------------
-- Draw left top box
local function drawLetopbox(Value, val2)	-- Strom 
		-- draw fixed Text
	lcd.drawText(57 - (lcd.getTextWidth(FONT_MINI,trans.current) / 2),2,trans.current,FONT_MINI)
	lcd.drawText(82, 31, "A", FONT_Normal)
	lcd.drawText(18, 50, trans.curmax, FONT_MINI)

		-- draw Values
	lcd.drawText(80 - lcd.getTextWidth(FONT_MAXI,string.format("%.0f",Value)),13,string.format("%.0f",Value),FONT_MAXI)
    lcd.drawText(86,50, string.format("%.0fA", val2), FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw left middle box
local function drawLemidbox(Value, val2)	-- Drehzahl und Empfängerspannung
    local laenge , spalte
		
    -- Drehzahl
	laenge = lcd.getTextWidth(FONT_MAXI,Value)   
    spalte = (100-laenge) / 2
	lcd.drawText(spalte + laenge +3, 82, "U/m", FONT_MINI)
	lcd.drawText(spalte,62, string.format("%.0f",Value), FONT_MAXI)
 
    -- Empfängerspannung
    lcd.drawText(4,112,"Rx:",FONT_NORMAL)
	lcd.drawText(106, 118, "V", FONT_MINI)
	lcd.drawText(41,98, string.format("%.2f",val2), FONT_MAXI)
  		
end
--------------------------------------------------------------------------------
-- Draw left bottom box
local function drawLebotbox(Value)	-- Temperatur

    lcd.drawText(17 ,136, string.format("TEMP: %.0f°",Value),FONT_BIG)

end
--------------------------------------------------------------------------------
-- Draw right top box
local function drawRitopbox(Value, val2)	-- Akkudaten
		-- draw fixed Text
	lcd.drawText(258 - (lcd.getTextWidth(FONT_MINI,trans.akku) / 2),2,trans.akku,FONT_MINI)
	lcd.drawText(283, 33, "mAh", FONT_MINI)
	lcd.drawText(204, 48, trans.capacity, FONT_MINI)

		-- draw Values
	lcd.drawText(278 - lcd.getTextWidth(FONT_MAXI, string.format("%.0f",Value)),12, string.format("%.0f",Value), FONT_MAXI)
    lcd.drawText(258,48, string.format("%s mAh", val2),FONT_MINI)
		
end
--------------------------------------------------------------------------------
-- Draw right middle box
local function drawRimidbox(Value, val2)	-- Laufzeit  ( min , sek)
	lcd.drawText(258 - (lcd.getTextWidth(FONT_MINI, trans.ftime)/2), 66, trans.ftime, FONT_MINI)
    lcd.drawText(258 - (lcd.getTextWidth(FONT_MAXI, string.format("%02d:%02d", Value, val2)) / 2), 74, string.format("%02d:%02d", Value, val2), FONT_MAXI)
		
		
end
--------------------------------------------------------------------------------
-- Draw right bottom box

local function drawRibotbox(Value)	-- BatterieWerte
    local laenge
	lcd.drawText(214, 114, trans.akkuvtg, FONT_MINI)

		-- draw Value Akku Voltage 
    laenge = lcd.getTextWidth(FONT_MAXI, string.format("%.2f",Value))
    lcd.drawText(296 - laenge,122, string.format("%.2f",Value),FONT_MAXI)
	lcd.drawText(300, 143, "V", FONT_MINI)

end
--------------------------------------------------------------------------------

-- Telemetriefenster 
local function Page1(width, height)

		-- animation demo at startup - fill tank up
	if( initAnimation ) then
		remaining = remaining - 5
		if remaining <= 0  then
			initAnimation = false
		end
	end	

		-- Set max/min percentage to 99/0 for drawing
	if( remaining > 99 ) then remaining = 99 end
	if( remaining < 0 ) then remaining = 0 end

   	lcd.drawRectangle(1,1,120,62,5)
    lcd.drawRectangle(1,66,120,31,5)
    lcd.drawRectangle(1,102,120,31,5)
    lcd.drawRectangle(1,136,120,23,5)
    lcd.drawRectangle(200,1,112,62,5)
    lcd.drawRectangle(200,67,112,44,5)
    lcd.drawRectangle(200,114,112,45,5)

	drawBattery(remaining, alarmValue)
	drawRibotbox(sensid1)	  				       --Variablen sind aktuelle Spannung 
	drawLetopbox(sensid2, maxcur)	               --Variablen sind aktueller Strom, Maximalstrom 
	drawRitopbox(sensid3, capa1)	               --Variablen sind Verbrauchte Kapazität, Akkukapazität
	drawLebotbox(sensid7)	           			   --Variablen sind Temperatur
	drawLemidbox(sensid6, sensid5 )	   			   --Variablen sind aktuelle Drehzahl, Empfängerspannung 
	drawRimidbox(min,sec)      	       			   --Variablen sind min ,sec 
	
end
--------------------------------------------------------------------------------
-- Take care of user's settings-changes
local function sensorChanged(value)
	sensorId  = sensorsAvailable[value].id
	system.pSave("sensorId", sensorId)
end

local function capa1Changed(value)
	capa1 = value
	system.pSave("capa1", capa1)
end

local function alarmValueChanged(value)
    alarmValue = value
    system.pSave("alarmValue", alarmValue)
end

local function alarmVoiceChanged(value)
    alarmVoice = value
    system.pSave("alarmVoice", alarmVoice)
end

local function timeSwChanged(value)
    timeSw = value
    system.pSave("timeSw", timeSw)
end

local function resSwChanged(value)
    resSw = value
    system.pSave("resSw", resSw)
end
--------------------------------------------------------------------------------
local function setupForm(formID)
    -- Sensoren nur auflisten, wenn das Menü aktiv ist, um Speicher zur Laufzeit zu erhalten
    -- (bis zu 25% eingespart, wenn das Menü nicht geöffnet ist)
    sensorsAvailable = {}
    local available = system.getSensors();
    local list={}
    local curIndex=-1
    local descr = ""
    for index,sensor in ipairs(available) do 
		if(sensor.param == 0) then
			list[#list+1] = sensor.label
			sensorsAvailable[#sensorsAvailable+1] = sensor
			if(sensor.id==sensorId ) then
				curIndex=#sensorsAvailable
			end 
		end
    end 
    
    local form, addRow, addLabel = form, form.addRow ,form.addLabel
    local addIntbox, addSelectbox = form.addIntbox, form.addSelectbox
    local addInputbox, addCheckbox = form.addInputbox, form.addCheckbox
    local addAudioFilebox, setButton = form.addAudioFilebox, form.setButton
	local setTitle, addSpacer = form.setTitle, form.addSpacer
    
	setTitle(trans.title)
				
	addSpacer(318,7)		

    addRow(2)
    addLabel({label = trans.selectsens, width=200})
    addSelectbox(list, curIndex, true, sensorChanged)
    
	addSpacer(318,7)		

    addRow(1)
    addLabel({label=trans.labelAlarm,font=FONT_BOLD})
    
    addRow(2)
    addLabel({label=trans.capa1, width=230})
    addIntbox(capa1, 0, 32767, 0, 0, 10, capa1Changed)
    
    addRow(2)
    addLabel({label=trans.alarmValue, width=230})
    addIntbox(alarmValue, 0, 100, 0, 0, 1, alarmValueChanged)
    
    form.addRow(2)
    addLabel({label=trans.voiceFile})
    addAudioFilebox(alarmVoice, alarmVoiceChanged)
	
	addSpacer(318,7)		

	addRow(1)
	addLabel({label="Powered by A.Strassburg "..Version.."  ", font=FONT_MINI, alignRight=true})
    
    collectgarbage()
end


---------------------------------------------------------------------------------
local function loop()

		-- Read Sensor ID 1 Mezon Spannung 
		sensor = system.getSensorByID(sensorId, 1)
		if(sensor and sensor.valid) then sensid1 = sensor.value	end

		-- Read Sensor ID 2 Mezon Strom 
		sensor = system.getSensorByID(sensorId, 2)
		if(sensor and sensor.valid) then sensid2 = sensor.value
			-- calculate Max Sensor 2
			if sensid2 > maxcur then maxcur = sensid2 end
		end

		-- Read Sensor ID 5 Mezon verbrauchte Kapazität
		sensor = system.getSensorByID(sensorId, 5)
		if(sensor and sensor.valid) then sensid3 = sensor.value
			remaining = (((capa1 - sensor.value) * 100) / capa1)		
			-- Wenn wir mehr als erlaubten Wert verbraucht haben , dann Alarm ansagen
			if(not playDone and remaining <= alarmValue and alarmVoice ~= "..." and sensor and sensor.valid) then
				system.playFile(alarmVoice,AUDIO_QUEUE)
				system.playNumber(remaining, 0, "%")
				playDone = true   
			end
			-- Wenn der Alarmwert überschritten ist, aktivieren wir den Alarm
			if(remaining > alarmValue) then playDone = false
			end
		end	
		
		-- Read Sensor ID 3 Mezon Empfängerspannung
		sensor = system.getSensorByID(sensorId, 3)
		if(sensor and sensor.valid) then sensid5 = sensor.value end

		-- Read Sensor ID 6 Mezon Drehzahl
		sensor = system.getSensorByID(sensorId, 6)
		if(sensor and sensor.valid) then sensid6 = sensor.value	end
		
	  -- Read Sensor ID 7 Mezon Temperatur
		sensor = system.getSensorByID(sensorId, 7)
		if(sensor and sensor.valid) then sensid7 = sensor.value end
		
		-- Read Sensor ID 8 Mezon RunTime
		sensor = system.getSensorByID(sensorId, 8)
		if(sensor and sensor.valid) then 
		  std = sensor.valHour
		  min = sensor.valMin
		  sec = sensor.valSec
		end

		
	   collectgarbage()
   
end


-------------------------------------------------------------
local function init(code1)
    local pLoad, registerForm, registerTelemetry = system.pLoad, system.registerForm, system.registerTelemetry
    remaining = 100
	model = system.getProperty("Model")
	owner = system.getUserName()
	today = system.getDateTime()
	sensorId = pLoad("sensorId", 0)
	capa1 = pLoad("capa1",0)
    alarmValue = pLoad("alarmValue", 0)
    alarmVoice = pLoad("alarmVoice", "...")
	timeSw = pLoad("timeSw")
	resSw = pLoad("resSw")
    registerForm(1, MENU_APPS, trans.appName1, setupForm)
    registerTelemetry(1, trans.appName1.." "..model, 4, Page1) --registers a full size Window
    collectgarbage()
end
--------------------------------------------------------------------------------
Version = "1.1"
setLanguage()
collectgarbage()
return {init=init, loop=loop, author="A.Strassburg", version=Version, name=trans.appName1}